# Unofficial Yandex Cloud Resource Provider

This lets you manage [Yandex Cloud](https://cloud.yandex.com) resources.

## Installing

This package is available for several languages/platforms:

### Node.js (JavaScript/TypeScript) Not working yet

To use from JavaScript or TypeScript in Node.js, install using either `npm`:

```bash
npm install @regrau/pulumi_yandex_unofficial
```

or `yarn`:

```bash
yarn add @regrau/pulumi_yandex_unofficial
```

### Python

To use from Python, install using `pip`:

```bash
pip install pulumi_yandex_unofficial
```

### Go

To use from Go, use `go get` to grab the latest version of the library:

```bash
go get github.com/regrau/pulumi-yandex/sdk/go/...
```

### .NET Not working yet

To use from .NET, install using `dotnet add package`:

```bash
dotnet add package Pulumi.Foo
```

## Configuration

The following configuration points are available for the `foo` provider:

- `foo:apiKey` (environment: `FOO_API_KEY`) - the API key for `foo`
- `foo:region` (environment: `FOO_REGION`) - the region in which to deploy resources

## Reference

For detailed reference documentation, please visit [the Pulumi registry](https://www.pulumi.com/registry/packages/foo/api-docs/).
